<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 29/06/12
 * Time: 16:27
 * To change this template use File | Settings | File Templates.
 */

class PercorreHomolognet {

    private $_nrOrg;
    private $_nrOrgPadrao;
    private $_nrEstruturaTrab;
    private $_mesCompetencia;
    private $_dtAux;
    private $_retrocesso;

    private $_homolognet;
    private $_homologMagnet;
    private $_dadosIniciaisHnet;
    private $_dadosIniciaisForm;

    private $_vinculom;
    private $_evento;
    private $_nrTipoModalidadeCalculo;
    private $_calculoFolha;

    private $_listaNrCalculoFolha;
    private $_listaEventosGrupoIncidencia;
    private $_itemGrupo;

    private $_formulario;
    private $_nrHierarquiaOrg;
    private $_tpInscricaoHierarquia;
    private $_nrHierarquiaTomador;
    private $_tpInscricaoHierarquiaTom;
    private $_dsOrdem;
    private $_dsInicio;
    private $_dsFim;
    private $_dtRescisaoIni;
    private $_dtRescisaoFim;
    private $_idProcessaVinculo;
    private $_idGeraMeioMagnetico;
    private $_dsCaminhoArquivo;
    private $_nrGrupoIncidencia;
    private $_nrGrupoHomolognet;
    static $_idComprovouAviso;
    static $_idDispensouAviso;


    public function __construct($tpProcessamento, $nrFormulario, Parametros $parametro, $dadosIniciais) {

        // Pegar mesCompetencia, nrOrg e nrOrgPadrao da Classe Parametros;
        $this->_nrOrg = $parametro->getNrOrgTrabalho();
        $this->_nrOrgPadrao = $parametro->getNrOrgPadrao();
        $this->_nrEstruturaTrab = $parametro->getNrEstrutTrab();
        $this->_mesCompetencia = new TkDateTime($parametro->getMesCompetencia());
        $this->_dtAux = new TkDateTime($this->_mesCompetencia);

        $this->_tipoMovimento = FpatipomovimentEntity::TP_MOV_MENSAL;

        $this->_nrTipoModalidadeCalculo = $parametro->getTipoModalidadeCalculo();
        $this->_calculoFolha = new FpacalculofolhaEntity();

        $this->_itemGrupo = new FpaGrpitemEntity();

        $this->_vinculom = new GpevinculomEntity();
        $this->_evento = new FpaeventomEntity(null, $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia);

        $this->_inicializaVariaveis($nrFormulario);

        $this->_homologMagnet = new FpaHomologmagnetEntity();
        $this->_homolognet = new Homolognet(
            $this->_nrOrg, $this->_nrOrgPadrao, $this->_mesCompetencia, $this->_formulario, $this->_homologMagnet,
            $this->_itemGrupo, $this->_listaNrCalculoFolha, $this->_listaEventosGrupoIncidencia
        );

        $this->_dadosIniciaisHnet = new RegistroDadosIniciaisHomolognet();
        $this->_dadosIniciaisForm = $dadosIniciais;

        $tpProcessamento = strtoupper($tpProcessamento);
        switch ($tpProcessamento){
            case Parametros::PROC_COMPETENCIA_MENSAL :
                $this->_retrocesso = false;
                break;
            case Parametros::PROC_RETROCESSO :
                $this->_retrocesso = true;
                break;
            default:
                tk_message('Tipo de processo '.$tpProcessamento.' invalido', 'warning');
        }

    }


    private function _inicializaVariaveis($nrFormulario) {

        // Retorna 85 meses do mes de competencia. Esta eh a data minima para os calculos de 
        $this->_dtAux->subMonth(RegistroHomolognet::MESES_CALCULO_FOLHA);

        $this->_buscaDadosFormulario($nrFormulario);
        $this->_itemGrupo->carregaItensGrupoPorGrupoIncidencia($this->_nrOrg, $this->_nrOrgPadrao, $this->_nrGrupoIncidencia);
        $this->_listaNrCalculoFolha = $this->_calculoFolha->retornaListaCalculoFolhaPorPeriodo(
            $this->_nrOrg, $this->_tipoMovimento, $this->_dtAux, $this->_mesCompetencia, $this->_nrTipoModalidadeCalculo
        );
        $this->_preparaListaEventosGrupoIncidencia();

    }


    public function percorre(){

        if ($this->_retrocesso === false) {
            try{
                $this->_geraHomolognet();
                tk_message('Arquivo gerado', 'success');
            }catch (Exception $e) {
                tk_warning($e->getMessage());

            }
        } else {
            try {
                $this->_homolognet->retroceder();
                tk_message('Retrocedido', 'success');
            } catch (Exception $e) {
                tk_warning($e->getMessage());
            }
        }
    }


    private function _geraHomolognet(){

        // Verifica se processa vinculo
        if ($this->_idProcessaVinculo === true){

            // Retorna vinculos demitidos no periodo pesquisado
            $vinculos = $this->_vinculom->retornaVinculosDemitidosMesCompetencia(
                $this->_nrOrg, $this->_mesCompetencia, $this->_dsInicio, $this->_dsFim, $this->_dtRescisaoIni,
                $this->_dtRescisaoFim, $this->_dsOrdem, $this->_nrEstruturaTrab
            );

            if($vinculos){

                // Loop nos vinculos chamando gerarHomolognet
                foreach($vinculos as $vinculo){

                    if($vinculo){

                        try {
                            $this->_homolognet->geraHomolognet($vinculo, $this->_tpInscricaoHierarquia, $this->_tpInscricaoHierarquiaTom);
//                            $this->_homolognet->geraHomolognet($vinculo, $this->_nrHierarquiaOrg, $this->_nrHierarquiaTomador, $this->_tpInscricaoHierarquia, $this->_tpInscricaoHierarquiaTom);
                        } catch(Exception $e){
                            //throw new Exception('Inconsistencia na geracao do registro HOMOLOGNET. '.$e->getMessage());
                            throw new Exception($e->getMessage());
                        }

                    }else{
                        throw new Exception('Vínculo '. $vinculo->getNrvinculom() . ' sem data de rescisão ou fora da data de competência.');
                    }

                }

                // So persiste se a lista nao estiver vazia.
                $qtdRegistros = $this->_homologMagnet->countItems();
                if ($qtdRegistros > 0) {
                    $this->_homologMagnet->persist();
                }

            }else{
                throw new Exception('Vínculo não demitido no período de rescisão informado.');
            }

        }

        // Gera o magnetico (XML)
        $this->_geraMagnetico();


    }


    private function _geraMagnetico(){

        // Retorna os registros do magnetico em ordem de empregador, empregado
        $registros = $this->_homologMagnet->retornaRegistros($this->_mesCompetencia, $this->_nrOrg);

        $this->_preparaDadosIniciais($this->_dadosIniciaisForm);

        $nrInscricao = null;
        $conteudo = null;

        //verifica se existe registro para o vínculo.
        if($registros) {

            // Loop nos registros
            foreach ($registros as $registro) {

                // Tratamento para gerar mais de uma estrutura na mesma Organizacao
                if ($registro->getCdinscestrut() !== $nrInscricao){
                    $nrInscricao = $registro->getCdinscestrut();

                    // Criando novo arquivo
                    $xml = new XMLWriter();
                    $xml->openMemory();
                    $xml->setIndent(true);
                    $xml->setIndentString('	');
                    $xml->startDocument("1.0", "ISO-8859-1");

                    if (empty($conteudo) === false){
                        //finaliza o xml para o empregador e gera o arquivo.
                        $xml->endElement(); //fim tag empregador
                        header( 'Content-type: text/xml' );
                        $conteudo = $xml->outputMemory(true);
                        $this->_geraArquivo($conteudo);
                    }

                }

                if ($registro->getIdtiporegistro() === Homolognet::EMPREGADOR){

                    // Cria nó principal (Empregador)
                    $xml->startElement(RegistroEmpregadorHomolognet::EMPREGADOR);
                    $xml->writeAttribute('xmlns','http://www.mte.gov.br/homolog-net_4_10');
                    $xml->writeAttributeNS('xmlns','xsi', null, 'http://www.w3.org/2001/XMLSchema-instance');

                    // Cria e gera bloco xml Dados Principais
                    $xml->startElement(RegistroDadosIniciaisHomolognet::DADOS_INICIAIS);
                    $this->_dadosIniciaisHnet->geraTag($xml);
                    $xml->endElement();

                    // Cria dados Empregador
                    $this->_homolognet->geraTagEmpregador($xml);
                }

                if ($registro->getIdtiporegistro() === Homolognet::EMPREGADO){

                    //cria nó empregado
                    $xml->startElement(RegistroEmpregadoHomolognet::EMPREGADO);
                    $this->_homolognet->geraTagEmpregado($xml);

                    //cria nó contrato - @todo verificar possibilidade de mais de um contrato.
                    $xml->startElement(RegistroContratoHomolognet::CONTRATO);
                    $this->_homolognet->geraTagContrato($xml);

                    //cria nó férias
                    $xml->startElement(RegistroFeriasHomolognet::FERIAS);
                    $this->_homolognet->geraTagFerias($xml);
                    $xml->endElement(); //fim tag ferias

                    //cria nó 13salario
                    $xml->startElement(Registro13SalarioHomolognet::DECIMO_TERCEIROS);
                    $this->_homolognet->geraTagDecimoTerceirosalario($xml);
                    $xml->endElement(); //fim tag 13salario

                    //cria nó movimentacoes
                    $xml->startElement(RegistroMovimentacaoHomolognet::MOVIMENTACOES);
                    $this->_homolognet->geraTagMovimentacao($xml);
                    $xml->endElement(); //fim tag movimentacoes

                    //cria nó financeiro
                    $xml->startElement(RegistroFinanceiroHomolognet::FINANCEIRO);
                    $this->_homolognet->geraTagFinanceiro($xml);
                    $xml->endElement(); //fim tag financeiro

//                            //cria nó descontos
                    $xml->startElement(RegistroDescontoHomolognet::DESCONTO);
                    $this->_homolognet->geraTagDesconto($xml);
                    $xml->endElement(); //fim tag descontos

//                              //cria nó codigo
//                            $xml->startElement(RegistroCodigoHomolognet::CODIGOS);
//                            $this->_homolognet->geraTagCodigo($xml);
//                            $xml->endElement();

                    $xml->endElement(); //fim tag contrato
                    $xml->endElement(); //fim tag empregado

                }

//                if ($registro->getIdtiporegistro() === Homolognet::CONTRATO){
//
//                    //cria nó contrato
//                    $xml->startElement(RegistroContratoHomolognet::CONTRATO);
//                    $this->_homolognet->geraTagContrato($xml);
//                    $xml->endElement();
//
//                }

                // Para cada registro (empregador, dados iniciais, empregado, contratos), gerar as tags de XML -
                /* Obs.: Olhar o que mais se adapta XMLWriter(mais leve) ou DOMDocument(mais robusto)*/


            }

            // Finaliza o xml para uma unica estrutura ou para a ultima estrutura do loop e gera o arquivo.
            $xml->endElement(); //fim tag empregador
            $xml->endElement(); //fim document
            header( 'Content-type: text/xml' );
            $conteudo = $xml->outputMemory(true);
            $this->_geraArquivo($conteudo);

        }else{
            throw new Exception('Não existe registro para o vínculo');
        }

    }


    private function _geraArquivo($conteudo){


        //Chama método para gerar o arquivo, passando os parâmetros: nome da pasta, nome do arquivo e extensão arquivo
        $nomePasta = "HOMOLOGNET";
        $nomeArquivo = "HOMOLOGNET.xml";
        $extensao = ".xml";
        $arquivo = \FPA::geraArquivo($nomePasta, $nomeArquivo, $extensao);

//        $filePath = 'C:\homolognet.xml';
//        $arquivo = new TkFile($filePath, true);
        $arquivo->add($conteudo);
//        $arquivo->save();

        $arquivo->save(false, null, 0777);
        $arquivo->download(substr($_SERVER['REQUEST_URI'], 0, strlen($_SERVER['REQUEST_URI']) - 12)."/".\FPA::getNrorgTrabalho()."/".$nomePasta."/".$nomeArquivo);
    }


    private function _preparaDadosIniciais($dadosInciaisForm){
        //@todo - Dados devem vir do formulario;
        $this->_dadosIniciaisHnet->geraRegistroDadosIniciais($dadosInciaisForm);
    }


    private function _buscaDadosFormulario($nrFormulario){
        $formulario = new FpaFormhomolognetEntity();
        $this->_formulario = $formulario->retornaDadosFormularioHomolognet($this->_nrOrg, $nrFormulario);
        if (is_object($this->_formulario) === true) {
            $this->_nrHierarquiaOrg = $this->_formulario->getNrhierarqorg();
            $this->_tpInscricaoHierarquia = $this->_formulario->getIdtpinschierarq();
            $this->_nrHierarquiaTomador = $this->_formulario->getNrhierartomador();
            $this->_tpInscricaoHierarquiaTom = $this->_formulario->getIdtpinschiertom();
            $this->_dsOrdem = $this->_formulario->getDsordem();
            $this->_dsInicio = $this->_formulario->getDsinicio();
            $this->_dsFim = $this->_formulario->getDsfim();
            $this->_idProcessaVinculo = $this->_formulario->getIdprocvinculo();
            $this->_idGeraMeioMagnetico = $this->_formulario->getIdgerameiomag();
            $this->_dsCaminhoArquivo = $this->_formulario->getDscaminhoarquivo();
            $this->_nrGrupoIncidencia = $this->_formulario->getNrgrpincide();
            $this->_nrGrupoHomolognet = $this->_formulario->getNrgrupohomolognet();

            $this->_idComprovouAviso = tk_get_field_value('IDCOMPROVOUAVISO');
            $this->_idDispensouAviso = tk_get_field_value('IDDISPENSOUAVISO');

            $dtInicio = $this->_formulario->getDtrescisaoini();
            if (empty($dtInicio) === true){
                $this->_dtRescisaoIni = new TkDateTime($this->_mesCompetencia);
            } else {
                $this->_dtRescisaoIni = new TkDateTime($dtInicio);
            }

            $dtFim = $this->_formulario->getDtrescisaofim();
            if (empty($dtFim) === true){
                $this->_dtRescisaoFim = new TkDateTime($this->_mesCompetencia);
                $this->_dtRescisaoFim->addMonth(1)->subDay(1);
            } else {
                $this->_dtRescisaoFim = new TkDateTime($dtFim);
            }

        }
    }


    private function _preparaListaEventosGrupoIncidencia(){
        $this->_listaEventosGrupoIncidencia = array();
        $listaTipoIncidencia = $this->_itemGrupo->getListaIncidencias();

        foreach ($listaTipoIncidencia as $tipoIncidencia){
            // Retornar os eventos da incidencia
            $nrEventos = FpaincideventoEntity::getEventos($this->_mesCompetencia, $tipoIncidencia);

            foreach($nrEventos as $nrEvento){
                $evento = $this->_evento->retornaEvento($nrEvento);
                $this->_listaEventosGrupoIncidencia[$nrEvento] = $evento;
            }
        }
    }


}
