/* Sistemas Integrados TEKNISA
  Documentos Fiscais de Sada

Nome: 5106_DFSTRGS.SQL

Descrio:
Ao excluir uma nota fiscal gerada por romaneio o sistema permite
a gerao de uma nova nota fiscal.

@C:\web_542\sql\end_conv\sqlServer\5106_DFSTRGS_ALT_ROMANEIO.SQL

Criao:
30/04/2012 - Fabrcio Marcelo da Silva
*/

IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ALT_ROMANEIO'
             AND TYPE   = 'TR'
             AND U.UID  = O.UID
             AND U.NAME = USER)
   DROP TRIGGER ALT_ROMANEIO
GO

CREATE TRIGGER ALT_ROMANEIO
ON NOTAFISCAL
FOR DELETE
AS
/*VARIVEIS DO CURSOR C_CURSORT*/
   DECLARE @V_CDFILIAL_OLD      VARCHAR(04);
   DECLARE @V_NRLANCTONF_OLD    VARCHAR(10);
   DECLARE @V_IDENTRSAIDOP_OLD  VARCHAR(01);
   DECLARE @V_CDFILIRECE_OLD    VARCHAR(04);
BEGIN
   DECLARE C_CURSORT CURSOR FOR
      SELECT CDFILIAL, NRLANCTONF, IDENTRSAIDOP, CDFILIRECE
        FROM DELETED
       WHERE CDFILIAL+NRLANCTONF NOT IN (SELECT CDFILIAL+NRLANCTONF FROM INSERTED);

   OPEN C_CURSORT;
   FETCH NEXT FROM C_CURSORT INTO @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD, @V_IDENTRSAIDOP_OLD, @V_CDFILIRECE_OLD;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF (@V_IDENTRSAIDOP_OLD = 'S') AND (NOT @V_CDFILIRECE_OLD IS NULL) BEGIN
         UPDATE ITEMROMANEIO
            SET NRLANCTONF = NULL
          WHERE CDFILIAL = @V_CDFILIAL_OLD
            AND NRLANCTONF = @V_NRLANCTONF_OLD;
      END;
      FETCH NEXT FROM C_CURSORT INTO @V_CDFILIAL_OLD, @V_NRLANCTONF_OLD, @V_IDENTRSAIDOP_OLD, @V_CDFILIRECE_OLD;
   END;

   CLOSE      C_CURSORT;
   DEALLOCATE C_CURSORT;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ALT_ROMANEIO','5.42.XXX';
GO

